Package org.lwjgl.opencl

# Class CL12

java.lang.Object
org.lwjgl.opencl.CL12

public final class CL12 extends Object
The core OpenCL 1.1 API

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`CL_BLOCKING`
cl_bool
`static final int`
`CL_COMMAND_BARRIER`
cl_device_type - bitfield
`static final int`
`CL_COMMAND_FILL_BUFFER`
cl_device_type - bitfield
`static final int`
`CL_COMMAND_FILL_IMAGE`
cl_device_type - bitfield
`static final int`
`CL_COMMAND_MIGRATE_MEM_OBJECTS`
cl_device_type - bitfield
`static final int`
`CL_COMPILE_PROGRAM_FAILURE`
Error Codes
`static final int`
`CL_CONTEXT_INTEROP_USER_SYNC`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_AFFINITY_DOMAIN_L1_CACHE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_AFFINITY_DOMAIN_L2_CACHE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_AFFINITY_DOMAIN_L3_CACHE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_AFFINITY_DOMAIN_L4_CACHE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_AFFINITY_DOMAIN_NEXT_PARTITIONABLE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_AFFINITY_DOMAIN_NUMA`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_BUILT_IN_KERNELS`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_DOUBLE_FP_CONFIG`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_IMAGE_MAX_ARRAY_SIZE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_IMAGE_MAX_BUFFER_SIZE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_LINKER_AVAILABLE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PARENT_DEVICE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PARTITION_AFFINITY_DOMAIN`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PARTITION_BY_AFFINITY_DOMAIN`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PARTITION_BY_COUNTS`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PARTITION_BY_COUNTS_LIST_END`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PARTITION_EQUALLY`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PARTITION_FAILED`
Error Codes
`static final int`
`CL_DEVICE_PARTITION_MAX_SUB_DEVICES`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PARTITION_PROPERTIES`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PARTITION_TYPE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PREFERRED_INTEROP_USER_SYNC`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_PRINTF_BUFFER_SIZE`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_REFERENCE_COUNT`
cl_device_type - bitfield
`static final int`
`CL_DEVICE_TYPE_CUSTOM`
cl_device_type - bitfield
`static final int`
`CL_FP_CORRECTLY_ROUNDED_DIVIDE_SQRT`
cl_device_type - bitfield
`static final int`
`CL_IMAGE_ARRAY_SIZE`
cl_device_type - bitfield
`static final int`
`CL_IMAGE_BUFFER`
cl_device_type - bitfield
`static final int`
`CL_IMAGE_NUM_MIP_LEVELS`
cl_device_type - bitfield
`static final int`
`CL_IMAGE_NUM_SAMPLES`
cl_device_type - bitfield
`static final int`
`CL_INVALID_COMPILER_OPTIONS`
Error Codes
`static final int`
`CL_INVALID_DEVICE_PARTITION_COUNT`
Error Codes
`static final int`
`CL_INVALID_IMAGE_DESCRIPTOR`
Error Codes
`static final int`
`CL_INVALID_LINKER_OPTIONS`
Error Codes
`static final int`
`CL_KERNEL_ARG_ACCESS_NONE`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_ACCESS_QUALIFIER`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_ACCESS_READ_ONLY`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_ACCESS_READ_WRITE`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_ACCESS_WRITE_ONLY`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_ADDRESS_CONSTANT`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_ADDRESS_GLOBAL`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_ADDRESS_LOCAL`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_ADDRESS_PRIVATE`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_ADDRESS_QUALIFIER`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_INFO_NOT_AVAILABLE`
Error Codes
`static final int`
`CL_KERNEL_ARG_NAME`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_TYPE_CONST`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_TYPE_NAME`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_TYPE_NONE`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_TYPE_QUALIFIER`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_TYPE_RESTRICT`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ARG_TYPE_VOLATILE`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_ATTRIBUTES`
cl_device_type - bitfield
`static final int`
`CL_KERNEL_GLOBAL_WORK_SIZE`
cl_device_type - bitfield
`static final int`
`CL_LINK_PROGRAM_FAILURE`
Error Codes
`static final int`
`CL_LINKER_NOT_AVAILABLE`
Error Codes
`static final int`
`CL_MAP_WRITE_INVALIDATE_REGION`
cl_device_type - bitfield
`static final int`
`CL_MEM_HOST_NO_ACCESS`
cl_device_type - bitfield
`static final int`
`CL_MEM_HOST_READ_ONLY`
cl_device_type - bitfield
`static final int`
`CL_MEM_HOST_WRITE_ONLY`
cl_device_type - bitfield
`static final int`
`CL_MEM_OBJECT_IMAGE1D`
cl_device_type - bitfield
`static final int`
`CL_MEM_OBJECT_IMAGE1D_ARRAY`
cl_device_type - bitfield
`static final int`
`CL_MEM_OBJECT_IMAGE1D_BUFFER`
cl_device_type - bitfield
`static final int`
`CL_MEM_OBJECT_IMAGE2D_ARRAY`
cl_device_type - bitfield
`static final int`
`CL_MIGRATE_MEM_OBJECT_CONTENT_UNDEFINED`
cl_device_type - bitfield
`static final int`
`CL_MIGRATE_MEM_OBJECT_HOST`
cl_device_type - bitfield
`static final int`
`CL_NON_BLOCKING`
cl_bool
`static final int`
`CL_PROGRAM_BINARY_TYPE`
cl_device_type - bitfield
`static final int`
`CL_PROGRAM_BINARY_TYPE_COMPILED_OBJECT`
cl_device_type - bitfield
`static final int`
`CL_PROGRAM_BINARY_TYPE_EXECUTABLE`
cl_device_type - bitfield
`static final int`
`CL_PROGRAM_BINARY_TYPE_LIBRARY`
cl_device_type - bitfield
`static final int`
`CL_PROGRAM_BINARY_TYPE_NONE`
cl_device_type - bitfield
`static final int`
`CL_PROGRAM_KERNEL_NAMES`
cl_device_type - bitfield
`static final int`
`CL_PROGRAM_NUM_KERNELS`
cl_device_type - bitfield
`static final int`
`CL_VERSION_1_2`
OpenCL Version

## Method Summary

Modifier and Type
Method
Description
`static int`
`clCompileProgram(CLProgram program, PointerBuffer device_list, CharSequence options, PointerBuffer input_header, CharSequence[] header_include_name, CLCompileProgramCallback pfn_notify)`
Overloads clCompileProgram.
`static int`
`clCompileProgram(CLProgram program, PointerBuffer device_list, CharSequence options, PointerBuffer input_header, CharSequence header_include_name, CLCompileProgramCallback pfn_notify)`
Overloads clCompileProgram.
`static int`
`clCompileProgram(CLProgram program, PointerBuffer device_list, ByteBuffer options, PointerBuffer input_headers, ByteBuffer[] header_include_names, CLCompileProgramCallback pfn_notify)`
Overloads clCompileProgram.
`static int`
`clCompileProgram(CLProgram program, PointerBuffer device_list, ByteBuffer options, PointerBuffer input_header, ByteBuffer header_include_name, CLCompileProgramCallback pfn_notify)`
Single null-terminated header include name.
`static int`
`clCompileProgramMulti(CLProgram program, PointerBuffer device_list, ByteBuffer options, PointerBuffer input_headers, ByteBuffer header_include_names, CLCompileProgramCallback pfn_notify)`
Overloads clCompileProgram.
`static CLMem`
`clCreateImage(CLContext context, long flags, ByteBuffer image_format, ByteBuffer image_desc, ByteBuffer host_ptr, IntBuffer errcode_ret)`
`static CLMem`
`clCreateImage(CLContext context, long flags, ByteBuffer image_format, ByteBuffer image_desc, FloatBuffer host_ptr, IntBuffer errcode_ret)`
`static CLMem`
`clCreateImage(CLContext context, long flags, ByteBuffer image_format, ByteBuffer image_desc, IntBuffer host_ptr, IntBuffer errcode_ret)`
`static CLMem`
`clCreateImage(CLContext context, long flags, ByteBuffer image_format, ByteBuffer image_desc, ShortBuffer host_ptr, IntBuffer errcode_ret)`
`static CLProgram`
`clCreateProgramWithBuiltInKernels(CLContext context, PointerBuffer device_list, CharSequence kernel_names, IntBuffer errcode_ret)`
Overloads clCreateProgramWithBuiltInKernels.
`static CLProgram`
`clCreateProgramWithBuiltInKernels(CLContext context, PointerBuffer device_list, ByteBuffer kernel_names, IntBuffer errcode_ret)`
`static int`
`clCreateSubDevices(CLDevice in_device, LongBuffer properties, PointerBuffer out_devices, IntBuffer num_devices_ret)`
`static int`
`clEnqueueBarrierWithWaitList(CLCommandQueue command_queue, PointerBuffer event_wait_list, PointerBuffer event)`
`static int`
`clEnqueueFillBuffer(CLCommandQueue command_queue, CLMem buffer, ByteBuffer pattern, long offset, long size, PointerBuffer event_wait_list, PointerBuffer event)`
`static int`
`clEnqueueFillImage(CLCommandQueue command_queue, CLMem image, ByteBuffer fill_color, PointerBuffer origin, PointerBuffer region, PointerBuffer event_wait_list, PointerBuffer event)`
`static int`
`clEnqueueMarkerWithWaitList(CLCommandQueue command_queue, PointerBuffer event_wait_list, PointerBuffer event)`
`static int`
`clEnqueueMigrateMemObjects(CLCommandQueue command_queue, PointerBuffer mem_objects, long flags, PointerBuffer event_wait_list, PointerBuffer event)`
`static int`
`clGetKernelArgInfo(CLKernel kernel, int arg_indx, int param_name, ByteBuffer param_value, PointerBuffer param_value_size_ret)`
`static CLProgram`
`clLinkProgram(CLContext context, PointerBuffer device_list, CharSequence options, PointerBuffer input_programs, CLLinkProgramCallback pfn_notify, IntBuffer errcode_ret)`
Overloads clLinkProgram.
`static CLProgram`
`clLinkProgram(CLContext context, PointerBuffer device_list, ByteBuffer options, PointerBuffer input_programs, CLLinkProgramCallback pfn_notify, IntBuffer errcode_ret)`
`static int`
`clReleaseDevice(CLDevice device)`
Warning: LWJGL will not automatically release any objects associated with sub-devices.
`static int`
`clRetainDevice(CLDevice device)`
`static int`
`clSetPrintfCallback(CLContext context, CLPrintfCallback pfn_notify)`
`static int`
`clUnloadPlatformCompiler(CLPlatform platform)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### CL_COMPILE_PROGRAM_FAILURE

public static final int CL_COMPILE_PROGRAM_FAILURE
Error Codes

See Also:
  - Constant Field Values

### CL_LINKER_NOT_AVAILABLE

public static final int CL_LINKER_NOT_AVAILABLE
Error Codes

See Also:
  - Constant Field Values

### CL_LINK_PROGRAM_FAILURE

public static final int CL_LINK_PROGRAM_FAILURE
Error Codes

See Also:
  - Constant Field Values

### CL_DEVICE_PARTITION_FAILED

public static final int CL_DEVICE_PARTITION_FAILED
Error Codes

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_INFO_NOT_AVAILABLE

public static final int CL_KERNEL_ARG_INFO_NOT_AVAILABLE
Error Codes

See Also:
  - Constant Field Values

### CL_INVALID_IMAGE_DESCRIPTOR

public static final int CL_INVALID_IMAGE_DESCRIPTOR
Error Codes

See Also:
  - Constant Field Values

### CL_INVALID_COMPILER_OPTIONS

public static final int CL_INVALID_COMPILER_OPTIONS
Error Codes

See Also:
  - Constant Field Values

### CL_INVALID_LINKER_OPTIONS

public static final int CL_INVALID_LINKER_OPTIONS
Error Codes

See Also:
  - Constant Field Values

### CL_INVALID_DEVICE_PARTITION_COUNT

public static final int CL_INVALID_DEVICE_PARTITION_COUNT
Error Codes

See Also:
  - Constant Field Values

### CL_VERSION_1_2

public static final int CL_VERSION_1_2
OpenCL Version

See Also:
  - Constant Field Values

### CL_BLOCKING

public static final int CL_BLOCKING
cl_bool

See Also:
  - Constant Field Values

### CL_NON_BLOCKING

public static final int CL_NON_BLOCKING
cl_bool

See Also:
  - Constant Field Values

### CL_DEVICE_TYPE_CUSTOM

public static final int CL_DEVICE_TYPE_CUSTOM
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_DOUBLE_FP_CONFIG

public static final int CL_DEVICE_DOUBLE_FP_CONFIG
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_LINKER_AVAILABLE

public static final int CL_DEVICE_LINKER_AVAILABLE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_BUILT_IN_KERNELS

public static final int CL_DEVICE_BUILT_IN_KERNELS
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_IMAGE_MAX_BUFFER_SIZE

public static final int CL_DEVICE_IMAGE_MAX_BUFFER_SIZE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_IMAGE_MAX_ARRAY_SIZE

public static final int CL_DEVICE_IMAGE_MAX_ARRAY_SIZE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PARENT_DEVICE

public static final int CL_DEVICE_PARENT_DEVICE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PARTITION_MAX_SUB_DEVICES

public static final int CL_DEVICE_PARTITION_MAX_SUB_DEVICES
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PARTITION_PROPERTIES

public static final int CL_DEVICE_PARTITION_PROPERTIES
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PARTITION_AFFINITY_DOMAIN

public static final int CL_DEVICE_PARTITION_AFFINITY_DOMAIN
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PARTITION_TYPE

public static final int CL_DEVICE_PARTITION_TYPE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_REFERENCE_COUNT

public static final int CL_DEVICE_REFERENCE_COUNT
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PREFERRED_INTEROP_USER_SYNC

public static final int CL_DEVICE_PREFERRED_INTEROP_USER_SYNC
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PRINTF_BUFFER_SIZE

public static final int CL_DEVICE_PRINTF_BUFFER_SIZE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_FP_CORRECTLY_ROUNDED_DIVIDE_SQRT

public static final int CL_FP_CORRECTLY_ROUNDED_DIVIDE_SQRT
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_CONTEXT_INTEROP_USER_SYNC

public static final int CL_CONTEXT_INTEROP_USER_SYNC
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PARTITION_EQUALLY

public static final int CL_DEVICE_PARTITION_EQUALLY
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PARTITION_BY_COUNTS

public static final int CL_DEVICE_PARTITION_BY_COUNTS
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PARTITION_BY_COUNTS_LIST_END

public static final int CL_DEVICE_PARTITION_BY_COUNTS_LIST_END
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_PARTITION_BY_AFFINITY_DOMAIN

public static final int CL_DEVICE_PARTITION_BY_AFFINITY_DOMAIN
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_AFFINITY_DOMAIN_NUMA

public static final int CL_DEVICE_AFFINITY_DOMAIN_NUMA
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_AFFINITY_DOMAIN_L4_CACHE

public static final int CL_DEVICE_AFFINITY_DOMAIN_L4_CACHE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_AFFINITY_DOMAIN_L3_CACHE

public static final int CL_DEVICE_AFFINITY_DOMAIN_L3_CACHE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_AFFINITY_DOMAIN_L2_CACHE

public static final int CL_DEVICE_AFFINITY_DOMAIN_L2_CACHE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_AFFINITY_DOMAIN_L1_CACHE

public static final int CL_DEVICE_AFFINITY_DOMAIN_L1_CACHE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_DEVICE_AFFINITY_DOMAIN_NEXT_PARTITIONABLE

public static final int CL_DEVICE_AFFINITY_DOMAIN_NEXT_PARTITIONABLE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MEM_HOST_WRITE_ONLY

public static final int CL_MEM_HOST_WRITE_ONLY
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MEM_HOST_READ_ONLY

public static final int CL_MEM_HOST_READ_ONLY
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MEM_HOST_NO_ACCESS

public static final int CL_MEM_HOST_NO_ACCESS
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MIGRATE_MEM_OBJECT_HOST

public static final int CL_MIGRATE_MEM_OBJECT_HOST
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MIGRATE_MEM_OBJECT_CONTENT_UNDEFINED

public static final int CL_MIGRATE_MEM_OBJECT_CONTENT_UNDEFINED
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MEM_OBJECT_IMAGE2D_ARRAY

public static final int CL_MEM_OBJECT_IMAGE2D_ARRAY
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MEM_OBJECT_IMAGE1D

public static final int CL_MEM_OBJECT_IMAGE1D
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MEM_OBJECT_IMAGE1D_ARRAY

public static final int CL_MEM_OBJECT_IMAGE1D_ARRAY
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MEM_OBJECT_IMAGE1D_BUFFER

public static final int CL_MEM_OBJECT_IMAGE1D_BUFFER
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_IMAGE_ARRAY_SIZE

public static final int CL_IMAGE_ARRAY_SIZE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_IMAGE_BUFFER

public static final int CL_IMAGE_BUFFER
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_IMAGE_NUM_MIP_LEVELS

public static final int CL_IMAGE_NUM_MIP_LEVELS
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_IMAGE_NUM_SAMPLES

public static final int CL_IMAGE_NUM_SAMPLES
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_MAP_WRITE_INVALIDATE_REGION

public static final int CL_MAP_WRITE_INVALIDATE_REGION
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_PROGRAM_NUM_KERNELS

public static final int CL_PROGRAM_NUM_KERNELS
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_PROGRAM_KERNEL_NAMES

public static final int CL_PROGRAM_KERNEL_NAMES
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_PROGRAM_BINARY_TYPE

public static final int CL_PROGRAM_BINARY_TYPE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_PROGRAM_BINARY_TYPE_NONE

public static final int CL_PROGRAM_BINARY_TYPE_NONE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_PROGRAM_BINARY_TYPE_COMPILED_OBJECT

public static final int CL_PROGRAM_BINARY_TYPE_COMPILED_OBJECT
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_PROGRAM_BINARY_TYPE_LIBRARY

public static final int CL_PROGRAM_BINARY_TYPE_LIBRARY
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_PROGRAM_BINARY_TYPE_EXECUTABLE

public static final int CL_PROGRAM_BINARY_TYPE_EXECUTABLE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ATTRIBUTES

public static final int CL_KERNEL_ATTRIBUTES
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ADDRESS_QUALIFIER

public static final int CL_KERNEL_ARG_ADDRESS_QUALIFIER
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ACCESS_QUALIFIER

public static final int CL_KERNEL_ARG_ACCESS_QUALIFIER
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_TYPE_NAME

public static final int CL_KERNEL_ARG_TYPE_NAME
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_TYPE_QUALIFIER

public static final int CL_KERNEL_ARG_TYPE_QUALIFIER
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_NAME

public static final int CL_KERNEL_ARG_NAME
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ADDRESS_GLOBAL

public static final int CL_KERNEL_ARG_ADDRESS_GLOBAL
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ADDRESS_LOCAL

public static final int CL_KERNEL_ARG_ADDRESS_LOCAL
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ADDRESS_CONSTANT

public static final int CL_KERNEL_ARG_ADDRESS_CONSTANT
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ADDRESS_PRIVATE

public static final int CL_KERNEL_ARG_ADDRESS_PRIVATE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ACCESS_READ_ONLY

public static final int CL_KERNEL_ARG_ACCESS_READ_ONLY
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ACCESS_WRITE_ONLY

public static final int CL_KERNEL_ARG_ACCESS_WRITE_ONLY
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ACCESS_READ_WRITE

public static final int CL_KERNEL_ARG_ACCESS_READ_WRITE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_ACCESS_NONE

public static final int CL_KERNEL_ARG_ACCESS_NONE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_TYPE_NONE

public static final int CL_KERNEL_ARG_TYPE_NONE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_TYPE_CONST

public static final int CL_KERNEL_ARG_TYPE_CONST
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_TYPE_RESTRICT

public static final int CL_KERNEL_ARG_TYPE_RESTRICT
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_ARG_TYPE_VOLATILE

public static final int CL_KERNEL_ARG_TYPE_VOLATILE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_KERNEL_GLOBAL_WORK_SIZE

public static final int CL_KERNEL_GLOBAL_WORK_SIZE
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_COMMAND_BARRIER

public static final int CL_COMMAND_BARRIER
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_COMMAND_MIGRATE_MEM_OBJECTS

public static final int CL_COMMAND_MIGRATE_MEM_OBJECTS
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_COMMAND_FILL_BUFFER

public static final int CL_COMMAND_FILL_BUFFER
cl_device_type - bitfield

See Also:
  - Constant Field Values

### CL_COMMAND_FILL_IMAGE

public static final int CL_COMMAND_FILL_IMAGE
cl_device_type - bitfield

See Also:
  - Constant Field Values

## Method Details

### clRetainDevice

public static int clRetainDevice(CLDevice device)

### clReleaseDevice

public static int clReleaseDevice(CLDevice device)
Warning: LWJGL will not automatically release any objects associated with sub-devices. The user is responsible for tracking and releasing everything prior to calling this method.

Parameters:
  `device` - the parent CLDevice

Returns:
  the error code

### clCreateSubDevices

public static int clCreateSubDevices(CLDevice in_device, LongBuffer properties, PointerBuffer out_devices, IntBuffer num_devices_ret)

### clCreateImage

public static CLMem clCreateImage(CLContext context, long flags, ByteBuffer image_format, ByteBuffer image_desc, ByteBuffer host_ptr, IntBuffer errcode_ret)

### clCreateImage

public static CLMem clCreateImage(CLContext context, long flags, ByteBuffer image_format, ByteBuffer image_desc, FloatBuffer host_ptr, IntBuffer errcode_ret)

### clCreateImage

public static CLMem clCreateImage(CLContext context, long flags, ByteBuffer image_format, ByteBuffer image_desc, IntBuffer host_ptr, IntBuffer errcode_ret)

### clCreateImage

public static CLMem clCreateImage(CLContext context, long flags, ByteBuffer image_format, ByteBuffer image_desc, ShortBuffer host_ptr, IntBuffer errcode_ret)

### clCreateProgramWithBuiltInKernels

public static CLProgram clCreateProgramWithBuiltInKernels(CLContext context, PointerBuffer device_list, ByteBuffer kernel_names, IntBuffer errcode_ret)

### clCreateProgramWithBuiltInKernels

public static CLProgram clCreateProgramWithBuiltInKernels(CLContext context, PointerBuffer device_list, CharSequence kernel_names, IntBuffer errcode_ret)
Overloads clCreateProgramWithBuiltInKernels.

### clCompileProgram

public static int clCompileProgram(CLProgram program, PointerBuffer device_list, ByteBuffer options, PointerBuffer input_header, ByteBuffer header_include_name, CLCompileProgramCallback pfn_notify)
Single null-terminated header include name.

### clCompileProgramMulti

public static int clCompileProgramMulti(CLProgram program, PointerBuffer device_list, ByteBuffer options, PointerBuffer input_headers, ByteBuffer header_include_names, CLCompileProgramCallback pfn_notify)
Overloads clCompileProgram.

Multiple null-terminated header include names, one after the other.

### clCompileProgram

public static int clCompileProgram(CLProgram program, PointerBuffer device_list, ByteBuffer options, PointerBuffer input_headers, ByteBuffer[] header_include_names, CLCompileProgramCallback pfn_notify)
Overloads clCompileProgram.

### clCompileProgram

public static int clCompileProgram(CLProgram program, PointerBuffer device_list, CharSequence options, PointerBuffer input_header, CharSequence header_include_name, CLCompileProgramCallback pfn_notify)
Overloads clCompileProgram.

### clCompileProgram

public static int clCompileProgram(CLProgram program, PointerBuffer device_list, CharSequence options, PointerBuffer input_header, CharSequence[] header_include_name, CLCompileProgramCallback pfn_notify)
Overloads clCompileProgram.

### clLinkProgram

public static CLProgram clLinkProgram(CLContext context, PointerBuffer device_list, ByteBuffer options, PointerBuffer input_programs, CLLinkProgramCallback pfn_notify, IntBuffer errcode_ret)

### clLinkProgram

public static CLProgram clLinkProgram(CLContext context, PointerBuffer device_list, CharSequence options, PointerBuffer input_programs, CLLinkProgramCallback pfn_notify, IntBuffer errcode_ret)
Overloads clLinkProgram.

### clUnloadPlatformCompiler

public static int clUnloadPlatformCompiler(CLPlatform platform)

### clGetKernelArgInfo

public static int clGetKernelArgInfo(CLKernel kernel, int arg_indx, int param_name, ByteBuffer param_value, PointerBuffer param_value_size_ret)

### clEnqueueFillBuffer

public static int clEnqueueFillBuffer(CLCommandQueue command_queue, CLMem buffer, ByteBuffer pattern, long offset, long size, PointerBuffer event_wait_list, PointerBuffer event)

### clEnqueueFillImage

public static int clEnqueueFillImage(CLCommandQueue command_queue, CLMem image, ByteBuffer fill_color, PointerBuffer origin, PointerBuffer region, PointerBuffer event_wait_list, PointerBuffer event)

### clEnqueueMigrateMemObjects

public static int clEnqueueMigrateMemObjects(CLCommandQueue command_queue, PointerBuffer mem_objects, long flags, PointerBuffer event_wait_list, PointerBuffer event)

### clEnqueueMarkerWithWaitList

public static int clEnqueueMarkerWithWaitList(CLCommandQueue command_queue, PointerBuffer event_wait_list, PointerBuffer event)

### clEnqueueBarrierWithWaitList

public static int clEnqueueBarrierWithWaitList(CLCommandQueue command_queue, PointerBuffer event_wait_list, PointerBuffer event)

### clSetPrintfCallback

public static int clSetPrintfCallback(CLContext context, CLPrintfCallback pfn_notify)